net.sf.saxon.tree.iter

## Class ArrayIterator<T extends Item>

- java.lang.Object
- - net.sf.saxon.tree.iter.ArrayIterator<T>

- All Implemented Interfaces:
    LastPositionFinder<T>, SequenceIterator<T>, GroundedIterator<T>, LookaheadIterator<T>, ReversibleIterator<T>, UnfailingIterator<T>

      public class ArrayIterator<T extends Item>
      extends Object
      implements UnfailingIterator<T>, ReversibleIterator<T>, LastPositionFinder<T>, LookaheadIterator<T>, GroundedIterator<T>

  ArrayIterator is used to enumerate items held in an array. The items are always held in the correct sorted order for the sequence.
  Author:
    Michael H. Kay

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected int` | `end`
    `protected T[]` | `items`
    `protected int` | `start`

    - ### Fields inherited from interface net.sf.saxon.om.SequenceIterator

      `GROUNDED, LAST_POSITION_FINDER, LOOKAHEAD`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ArrayIterator(T[] nodes)` Create an iterator over all the items in an array
    `ArrayIterator(T[] items, int start, int end)` Create an iterator over a range of an array.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Close the iterator.
    `T` | `current()` Get the current item in the array
    `ArrayIterator<T>` | `getAnother()` Get another iterator over the same items
    `T[]` | `getArray()` Get the underlying array
    `int` | `getEndPosition()` Get the end position in the array
    `int` | `getLength()` Get the number of items in the part of the array being processed
    `int` | `getProperties()` Get properties of this iterator, as a bit-significant integer.
    `SequenceIterator<T>` | `getReverseIterator()` Get an iterator that processes the same items in reverse order
    `int` | `getStartPosition()` Get the initial start position
    `boolean` | `hasNext()` Test whether there are any more items
    `SequenceIterator<T>` | `makeSliceIterator(int min, int max)` Create a new ArrayIterator over the same items, with a different start point and end point
    `GroundedValue` | `materialize()` Return a SequenceValue containing all the items in the sequence returned by this SequenceIterator
    `T` | `next()` Get the next item in the array
    `int` | `position()` Get the position of the current item in the array

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### items

          protected T extends Item[] items

    - #### start

          protected int start

    - #### end

          protected int end

  - ### Constructor Detail

    - #### ArrayIterator

          public ArrayIterator(T[] nodes)

      Create an iterator over all the items in an array
      Parameters:
        `nodes` - the array (of any items, not necessarily nodes) to be processed by the iterator

    - #### ArrayIterator

          public ArrayIterator(T[] items,
                       int start,
                       int end)

      Create an iterator over a range of an array. Note that the start position is zero-based
      Parameters:
        `items` - the array (of nodes or simple values) to be processed by the iterator
        `start` - the position of the first item to be processed (numbering from zero). Must be between zero and nodes.length-1; if not, undefined exceptions are likely to occur.
        `end` - position of first item that is NOT returned, zero-based. Must be beween 1 and nodes.length; if not, undefined exceptions are likely to occur.

  - ### Method Detail

    - #### makeSliceIterator

          public SequenceIterator<T> makeSliceIterator(int min,
                                              int max)

      Create a new ArrayIterator over the same items, with a different start point and end point
      Parameters:
        `min` - the start position (1-based) of the new ArrayIterator relative to the original
        `max` - the end position (1-based) of the last item to be delivered by the new ArrayIterator, relative to the original. For example, min=2, max=3 delivers the two items ($base[2], $base[3]). Set this to Integer.MAX_VALUE if there is no end limit.
      Returns:
        an iterator over the items between the min and max positions

    - #### hasNext

          public boolean hasNext()

      Test whether there are any more items
      Specified by:
        `hasNext` in interface `LookaheadIterator<T extends Item>`
      Returns:
        true if there are more items

    - #### next

          public T next()

      Get the next item in the array
      Specified by:
        `next` in interface `SequenceIterator<T extends Item>`
      Specified by:
        `next` in interface `UnfailingIterator<T extends Item>`
      Returns:
        the next item in the array

    - #### current

          public T current()

      Get the current item in the array
      Specified by:
        `current` in interface `SequenceIterator<T extends Item>`
      Specified by:
        `current` in interface `UnfailingIterator<T extends Item>`
      Returns:
        the item returned by the most recent call of next()

    - #### position

          public int position()

      Get the position of the current item in the array
      Specified by:
        `position` in interface `SequenceIterator<T extends Item>`
      Specified by:
        `position` in interface `UnfailingIterator<T extends Item>`
      Returns:
        the current position (starting at 1 for the first item)

    - #### getLength

          public int getLength()

      Get the number of items in the part of the array being processed
      Specified by:
        `getLength` in interface `LastPositionFinder<T extends Item>`
      Returns:
        the number of items; equivalently, the position of the last item

    - #### close

          public void close()

      Description copied from interface: `SequenceIterator`
      Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. This may enable the supplier to release resources. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

      (Currently, closing an iterator is important only when the data is being "pushed" in another thread. Closing the iterator terminates that thread and means that it needs to do no additional work. Indeed, failing to close the iterator may cause the push thread to hang waiting for the buffer to be emptied.)

      Specified by:
        `close` in interface `SequenceIterator<T extends Item>`

    - #### getAnother

          public ArrayIterator<T> getAnother()

      Get another iterator over the same items
      Specified by:
        `getAnother` in interface `SequenceIterator<T extends Item>`
      Specified by:
        `getAnother` in interface `UnfailingIterator<T extends Item>`
      Returns:
        a new ArrayIterator

    - #### getReverseIterator

          public SequenceIterator<T> getReverseIterator()

      Get an iterator that processes the same items in reverse order
      Specified by:
        `getReverseIterator` in interface `ReversibleIterator<T extends Item>`
      Returns:
        a new ArrayIterator

    - #### getArray

          public T[] getArray()

      Get the underlying array
      Returns:
        the underlying array being processed by the iterator

    - #### getStartPosition

          public int getStartPosition()

      Get the initial start position
      Returns:
        the start position of the iterator in the array (zero-based)

    - #### getEndPosition

          public int getEndPosition()

      Get the end position in the array
      Returns:
        the position in the array (zero-based) of the first item not included in the iteration

    - #### materialize

          public GroundedValue materialize()

      Return a SequenceValue containing all the items in the sequence returned by this SequenceIterator
      Specified by:
        `materialize` in interface `GroundedIterator<T extends Item>`
      Returns:
        the corresponding SequenceValue

    - #### getProperties

          public int getProperties()

      Get properties of this iterator, as a bit-significant integer.
      Specified by:
        `getProperties` in interface `SequenceIterator<T extends Item>`
      Returns:
        the properties of this iterator. This will be some combination of properties such as `SequenceIterator.GROUNDED`, `SequenceIterator.LAST_POSITION_FINDER`, and `SequenceIterator.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.